﻿
-- Author      : Dan
-- Create Date : 4/20/2011 2:08:54 PM

local lastupdate,nextupdate,mana1,mana2,manaused,base, casting, powerType, partyStatus, powerToken, burning;
local warningStatus = 0;
local warningTimer = 0;

-- Default Values

local defaultAlertText = "%N will be OOM in %Ss";
local defaultAlertTime = 25;
local defaultFrameScale = 1;
local defaultFrameLocked = 0;
local defaultOocOpac = 0.8;
local defaultIcOpac = 1.0;
local defaultManaUser = nil;
local manaused = 0;
mana1 = 0;
mana2 = 0;

function OOM_OnLoad()
end


function EDIT_OnLoad()
end

function check_defaults()
    if frameScale == nil then
		OOM:SetScale(1);
	else 
		OOM:SetScale(frameScale);
	end

	if frameLocked == nil then
		OOM:SetMovable(1);
		frameLocked = 0;
	else
		if frameLocked == 0 then
			OOM:SetMovable(1);
		else
			OOM:SetMovable(0);
		end
	end
	if oocOpac == nil then
		oocOpac = defaultOocOpac;
	end
	if cOpac == nil then
		cOpac = defaultIcOpac;
	end
end

-- Update Function

function updateScript()
	
    check_defaults();

	base, casting = GetManaRegen()
	local mps = floor(manaused);
	local timetillempty;

	if manaused < 0 then
		burning = 0;
		OOM:SetAlpha(1);
		RateText:SetTextColor(0,1,0,1);
		timetillempty = abs (floor( (UnitManaMax("player")-UnitMana("player"))/mps));
	    RateText:SetText("+"..abs(mps).." mana/s");
		TimeText:SetText("Full Mana In: "..timetillempty.."s");
	elseif manaused > 0 then
		burning = 1;
		OOM:SetAlpha(1);
		RateText:SetTextColor(1,0,0,1);
		timetillempty = floor(UnitMana("player")/mps);
	    RateText:SetText("-"..mps.." mana/s");
		TimeText:SetText("OOM In: "..timetillempty.."s");
	else 
		burning = 0;
		RateText:SetTextColor(0,0,1,1);
		OOM:SetAlpha(0.6);
	    RateText:SetText("Not Casting");
		TimeText:SetText("");
	end

	if UnitInParty("player") then
		if GetRealNumPartyMembers() > 0 then
			if UnitInRaid("player") then
				partyStatus = "RAID";
			else		
				partyStatus = "PARTY";
			end
		else 
			partyStatus = "0";
		end
	end

	if time() > nextupdate then
		manaused = mana1 - UnitMana("player");
		mana1 = UnitMana("player");
		nextupdate = time() +1;
	end

	local manapc = floor((UnitMana("player")/UnitManaMax("player"))*100);
	ManaText:SetText("Mana: "..manapc.."%");

	if warningStatus == 0 then
		Button_Alerts:SetText("Alert Disabled");
	else 
		Button_Alerts:SetText("Alert Enabled");
		alertTime = tonumber(alertTime);
		if manapc < alertTime and time() > warningTimer and burning == 1 and UnitIsDeadOrGhost("player") == nil then
			warningTimer = time()+30;
			if alertText == nil then
                local atext = defaultAlertText;
			else
                local atext = alertText;
			end
				a,c = strreplace(atext,"%N",UnitName("player"),10);
				a,c = strreplace(a,"%T",UnitName("target"),10);
				a,c = strreplace(a,"%F",UnitName("focus"),10);
				a,c = strreplace(a,"%P",UnitName("pet"),10);
				a,c = strreplace(a,"%S",timetillempty,10);
 			if partyStatus == "0" then
                Print(a);
			else
				SendChatMessage(a, partyStatus);
			end
		end

	end
end

-- Input Scripts

function ButtonAlerts_OnClick()
    	if warningStatus == 0 then
		if alertText == nil then
			alertText = defaultAlertText;
		end
		warningStatus = 1;
	else 
		warningStatus = 0;
	end
end

function ButtonOptions_OnClick()
	if alertText == nil then
		alertText = defaultAlertText;
	end
	if alertTime == nil then
		alertTime = defaultAlertTime;
	end
	if frameScale == nil then
		frameScale = defaultFrameScale;
	end
	if frameLocked == nil then
		frameLocked = 0;
	end
	if oocOpac == nil then
		oocOpac = defaultOocOpac;
	end
	if cOpac == nil then
		cOpac = defaultIcOpac;
	end
	if frameLocked == 1 then
		FrameLockedToggle:SetChecked(1);
	else 
		FrameLockedToggle:SetChecked(0);
	end
    EDIT:Show()
	AlertTextBox:SetText(alertText);
	AlertTimeBox:SetText(alertTime);
	FrameScaleBox:SetText(frameScale);
end

function SaveButton_OnClick()
	alertText = AlertTextBox:GetText();
	alertTime = tonumber(AlertTimeBox:GetText());
	frameScale = tonumber(FrameScaleBox:GetText());
	if FrameLockedToggle:GetChecked() == 1 then
		frameLocked = 1;
	else 
		frameLocked = 0;
	end
	EDIT:Hide()
end



partyStatus = "0";
powerType, powerToken, altR, altG, altB = UnitPowerType("player");
nextupdate = time()-1;

